package model

// 要塞皮肤表-FortMode exported from 要塞配置.xlsx
type FortMode struct {
	Uid   int64  `json:"Uid"`   // 唯一编号
	Name  string `json:"Name"`  // 皮肤名字
	Skill int64  `json:"Skill"` // 皮肤技能  0：无
	// Res          `json:"Res"` // 皮肤资源
	UnlockItem   int64  `json:"UnlockItem"`   // 解锁道具  0：无
	GetType      int64  `json:"GetType"`      // 获得方式  0：初始获得 1：解锁获得
	Time         int64  `json:"Time"`         // 动画总时长 秒  普通攻击的动画总时长 美术根据策划设计的攻速决定
	AtkPoint     int64  `json:"AtkPoint"`     // 攻击帧 秒  攻击动画中第X秒造成伤害  近战是伤害帧时间 远程是子弹出生时间
	Speed        int64  `json:"Speed"`        // 子弹速度  每秒飞行像素格数 程序判断是近战/远程
	BulletRes    string `json:"BulletRes"`    // 子弹资源
	BulletEndRes string `json:"BulletEndRes"` // 子弹爆炸资源
} // package model

// 要塞皮肤升星表-FortModeAdvance exported from 要塞配置.xlsx
type FortModeAdvance struct {
	Uid        int64     `json:"Uid"`        // 唯一编号
	ModeId     int64     `json:"ModeId"`     // 皮肤编号
	Star       int64     `json:"Star"`       // 升星等级
	NextExpend [][]int64 `json:"NextExpend"` // 下级消耗  注：第1位是升级材料
	Deep       float64   `json:"Deep"`       // 伤害加深/%
} // package model

// 要塞升级表-FortUpList exported from 要塞配置.xlsx
type FortLevel struct {
	ID        int64     `json:"ID"`        // 要塞等级
	Ant       int64     `json:"Ant"`       // 基础攻击力  整数值
	Attr      int64     `json:"Attr"`      // 攻击属性  1：物理 2：魔法 3:全能
	Pen       int64     `json:"Pen"`       // 全能穿透  整数值 全局生效
	Apen      int64     `json:"Apen"`      // 物理穿透  整数值 全局生效
	Mpen      int64     `json:"Mpen"`      // 魔法穿透  整数值 全局生效
	Td        int64     `json:"Td"`        // 真实伤害  整数值 无视抗性
	Hp        int64     `json:"Hp"`        // 血量  整数值
	As        int64     `json:"As"`        // 攻速  小数值 1秒攻击多少次，越大攻速越快
	Crt       float64   `json:"Crt"`       // 暴击率  小数值 展示百分比
	Dmg       int64     `json:"Dmg"`       // 暴击伤害  小数值 展示百分比
	Heal      int64     `json:"Heal"`      // 治疗力  整数值 控制恢复量
	GridLimit int64     `json:"GridLimit"` // 联结网格块上限
	Range     int64     `json:"Range"`     // 警戒范围 普攻范围  整数值 以此地块为中心的半径像素大小 进入此范围英雄开始攻击
	UpText    string    `json:"UpText"`    // 升星技能加成文本
	UpExpend  [][]int64 `json:"UpExpend"`  // 下级消耗材料  [[道具ID，数量]]
}

// 要塞天赋-Talent exported from 要塞天赋配置.xlsx
type FortTalent struct {
	Uid     int64     `json:"Uid"`     // 唯一ID
	Next    int64     `json:"Next"`    // 下级天赋
	Tpye    int64     `json:"Tpye"`    // 天赋类型 1--主天赋 2--副天赋
	Lv      int64     `json:"Lv"`      // 等级要求
	Icon    string    `json:"Icon"`    // 图标资源
	Ant     int64     `json:"Ant"`     // 攻击
	Hp      int64     `json:"Hp"`      // 生命
	Heal    int64     `json:"Heal"`    // 治疗力
	As      float64   `json:"As"`      // 攻速
	Crt     float64   `json:"Crt"`     // 暴击率
	Td      int64     `json:"Td"`      // 真伤
	Range   int64     `json:"Range"`   // 攻击范围
	PAnt    float64   `json:"PAnt"`    // 攻击百分比
	Pen     float64   `json:"Pen"`     // 穿透
	PHp     float64   `json:"PHp"`     // 生命百分比
	Des     string    `json:"Des"`     // 天赋描述
	Consume [][]int64 `json:"Consume"` // 消耗
}
