package model

// 符文表-Rune exported from 符文配置.xlsx
type Rune struct {
	Uid            int64   `json:"Uid"`            // 唯一ID
	Type           int64   `json:"Type"`           // 符文类型 1--凯旋符文 2--均衡符文 3--专注符文 4--战争符文 5--戒律符文 6--潜能符文
	Name           string  `json:"Name"`           // 名称
	FortModeLv     int64   `json:"FortModeLv"`     // 要塞等级要求
	Res            string  `json:"Res"`            // 资源
	Grade          int64   `json:"Grade"`          // 品阶
	Quality        int64   `json:"Quality"`        // 品质 1--白 2--绿 3--蓝 4--紫 5--橙 6--红
	Ant            int64   `json:"Ant"`            // 领主攻击
	PAnt           float64 `json:"PAnt"`           // 英雄攻击
	UpType         int64   `json:"UpType"`         // 升级属性
	Num            int64   `json:"Num"`            // 词条数量
	Disintegration []int64 `json:"Disintegration"` // 分解道具
}

// 符文升级表-RuneUp exported from 符文配置.xlsx
type RuneLevel struct {
	Uid    int64     `json:"Uid"`    // 唯一ID
	UpType int64     `json:"UpType"` // 升级类型
	Lv     int64     `json:"Lv"`     // 等级
	IsSelf int64     `json:"IsSelf"` // 领主攻击数值增加值
	Way    float64   `json:"Way"`    // 英雄攻击数值增加值
	Range  [][]int64 `json:"Range"`  // 消耗
}

// 符文重铸词条表-RuneEntry exported from 符文配置.xlsx
type RuneEntry struct {
	Uid     int64     `json:"Uid"`     // 唯一ID
	Des     string    `json:"Des"`     // 词条描述
	AttType int64     `json:"AttType"` // 属性类型
	Down    int64     `json:"Down "`   // 品阶下限
	Up      int64     `json:"Up"`      // 品阶上限
	Range   []float64 `json:"Range"`   // 数值范围
	Weight  int64     `json:"Weight"`  // 权重
}

// 符文重铸消耗表-RuneUse exported from 符文配置.xlsx
type RuneUse struct {
	Uid     int64   `json:"Uid"`     // 唯一ID
	Grade   int64   `json:"Grade"`   // 品阶
	Quality int64   `json:"Quality"` // 品质
	RuneUse []int64 `json:"RuneUse"` // 重铸消耗
	LockUse []int64 `json:"LockUse"` // 锁定消耗 (每锁定1条的消耗）
}
